/*
 * - Have main thread run accepting incoming two calls via DO
 * - -doExternal
 * - -doInternal
 *
 */

#include <Foundation/Foundation.h>



@interface Test: NSObject
{
}

@end



@implementation Test

- (void) doInternal
{
    NSLog (@"TT -- Internal");
    [NSThread sleepUntilDate: [NSDate dateWithTimeIntervalSinceNow: 0.05]];
}


- (void) doExternal
{
    int i;
    NSLog (@"TT -- External");
    for (i = 0; i < 20; ++i)
        {
        [[NSRunLoop currentRunLoop] runMode: NSDefaultRunLoopMode beforeDate:
                                        [NSDate dateWithTimeIntervalSinceNow: 0.005]];
        }
    
}


- (void) doInternalThread
{
    id arp = [NSAutoreleasePool new];
    id proxy = [NSConnection rootProxyForConnectionWithRegisteredName: @"Thread-Test"
                             host: nil];
    [proxy retain];
    while (YES)
        {
        [proxy doInternal];
        [arp release];
        arp = [NSAutoreleasePool new];
        }
    [proxy retain];
    [arp release];
}


- (void) doExternalThread
{
    id arp = [NSAutoreleasePool new];
    id proxy = [NSConnection rootProxyForConnectionWithRegisteredName: @"Thread-Test"
                             host: nil];
    [proxy retain];

    while (YES)
        {
        [proxy doExternal];
        [arp release];
        arp = [NSAutoreleasePool new];
        }
    [proxy release];
    [arp release];
}

    

@end


int main (void)
{
    id arp = [NSAutoreleasePool new];
    id test = [Test new];

    [[NSConnection defaultConnection] setRootObject: test];
    [[NSConnection defaultConnection] registerName: @"Thread-Test"];
    
    [NSThread detachNewThreadSelector: @selector (doInternalThread) toTarget: test withObject: nil];
    [NSThread detachNewThreadSelector: @selector (doExternalThread) toTarget: test withObject: nil];

    while (YES)
        {
        [[NSRunLoop currentRunLoop] runMode: NSDefaultRunLoopMode beforeDate: [NSDate distantFuture]];
        [arp release];
        arp = [NSAutoreleasePool new];
        }
    [test release];
}
